interface Client {
    request(source: string, args: any[]): any;
}
export interface SourceLocation {
    filename: string;
    line: number;
    column: number;
}
export interface RemoteFunction extends Function {
    (...args: any[]): any;
    isRemoteFunction?: boolean;
    client?: Client;
    source?: string;
    bound?: boolean;
    sourceLoc?: SourceLocation;
}
export interface BoundRemoteFunction extends Function {
    remoteFunction: RemoteFunction;
}
/** Create a new remote function */
export declare function func(sourceInput: TemplateStringsArray | Function | string): RemoteFunction;
export declare function func<RpcT>(client: Client, sourceInput: TemplateStringsArray | Function | string): RpcT & BoundRemoteFunction;
/** Bind a remote function to a client */
export declare function bind<T>(client: Client, serviceName: string): T;
export declare function bind<T>(client: Client, remoteFunction: T & RemoteFunction): T & BoundRemoteFunction;
export {};
